/*------------------------------- phasicFlow ---------------------------------
      O        C enter of
     O O       E ngineering and
    O   O      M ultiscale modeling of
   OOOOOOO     F luid flow       
------------------------------------------------------------------------------
  Copyright (C): www.cemf.ir
  email: hamid.r.norouzi AT gmail.com
------------------------------------------------------------------------------  
Licence:
  This file is part of phasicFlow code. It is a free software for simulating 
  granular and multiphase flows. You can redistribute it and/or modify it under
  the terms of GNU General Public License v3 or any other later versions. 
 
  phasicFlow is distributed to help others in their research in the field of 
  granular and multiphase flows, but WITHOUT ANY WARRANTY; without even the
  implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

-----------------------------------------------------------------------------*/

#ifndef __rectMeshFields_H__
#define __rectMeshFields_H__

#include "rectMeshField.H"

namespace pFlow
{

template<typename T>
using rectMeshField_H 		= rectMeshField<T,HostSpace>;

using int8RectMeshField_H  = rectMeshField<int8, HostSpace>;

using int32RectMeshField_H 	= rectMeshField<int32, HostSpace>;

using int64RectMeshField_H  = rectMeshField<int64, HostSpace>;

using realRectMeshField_H	= rectMeshField<real, HostSpace>;

using realx3RectMeshField_H	= rectMeshField<realx3, HostSpace>;

}


#endif // __rectMeshFields_H__
